"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContextUtils = void 0;

class ContextUtils {
  constructor(builder) {
    this.builder = builder;
  }

  markAsRead(context) {
    context["api"].messages.markAsRead({
      peer_id: context.peerId
    }).catch(() => null);
  }

  editMessage(messageParams, event = "") {
    const context = this.builder.sentContext;

    if (context) {
      if (this.builder.sendMethod !== "send_new") {
        return context.editMessage(messageParams).catch(error => {
          if ((error === null || error === void 0 ? void 0 : error.code) === 909) {
            return context.send(messageParams).then(context => {
              this.builder.sentContext = context;
              this.builder.saveContext();
              return context;
            });
          }

          throw error;
        });
      } else {
        if (event !== "stop") {
          return context.send(messageParams).then(context => {
            this.builder.sentContext = context;
            this.builder.saveContext();
            return context;
          });
        }
      }
    }
  }

}

exports.ContextUtils = ContextUtils;