"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "PagesBuilder", {
  enumerable: true,
  get: function () {
    return _PagesBuilder.PagesBuilder;
  }
});
Object.defineProperty(exports, "pagesStorage", {
  enumerable: true,
  get: function () {
    return _PagesBuilder.pagesStorage;
  }
});
exports.PagesManager = void 0;

var _PagesBuilder = require("./PagesBuilder");

class PagesManager {
  constructor() {
    this.fallbackHandler = null;
  }

  get middleware() {
    return (context, next) => {
      var _context$messagePaylo, _context$eventPayload;

      context.pagesBuilder = context.pageBuilder = () => new _PagesBuilder.PagesBuilder({
        context
      });

      const builderId = (context === null || context === void 0 ? void 0 : (_context$messagePaylo = context.messagePayload) === null || _context$messagePaylo === void 0 ? void 0 : _context$messagePaylo.builder_id) || (context === null || context === void 0 ? void 0 : (_context$eventPayload = context.eventPayload) === null || _context$eventPayload === void 0 ? void 0 : _context$eventPayload.builder_id);

      if (builderId) {
        const pagesInstance = _PagesBuilder.pagesStorage.get(builderId);

        if (pagesInstance) {
          pagesInstance.messageMiddleware(context);
        } else {
          if (this.fallbackHandler) {
            return this.fallbackHandler(context, next);
          }
        }
      }

      return next();
    };
  }
  /**
   * Функция для проверки наличия сборщика
   */


  static hasBuilder(builderId) {
    return _PagesBuilder.pagesStorage.has(builderId);
  }
  /**
   * Метод для установки обработчика при отсутствии сборщика
   */


  onFallback(handler) {
    this.fallbackHandler = handler;
    return this;
  }

}

exports.PagesManager = PagesManager;